<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2010 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: ajax_poll_panel.php
| Author: Khalid545
| Original file author: Nick Jones (Digitanium)
| URL: http://khalidb.co.cc/
| E-Mail: khalidd545@gmail.com
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

include INFUSIONS."ajax_poll_panel/infusion_db.php";

if (file_exists(INFUSIONS."ajax_poll_panel/locale/".$settings['locale'].".php")) {
	include INFUSIONS."ajax_poll_panel/locale/".$settings['locale'].".php";
} else {
	include INFUSIONS."ajax_poll_panel/locale/English.php";
}

echo "<script type='text/javascript'>
$(document).ready(function(){  
	$('#poll').submit(function(){
		var form = $(this),
		formData = form.serialize(),
		formUrl = form.attr('action'),
		formMethod = form.attr('method')

		$.ajax({
			url: formUrl,
			type: formMethod,
			data: formData,
			success:function(data){
				$('#poll').html(data);
			}
		})
		return false;
	})
})
</script>";

$link = FUSION_SELF.(FUSION_QUERY ? "?".FUSION_QUERY : "");

openside($locale['APP_100']);
if (isset($_POST['cast_vote'])) {
	vote($_POST['poll_id'], $_POST['voteoption']);
}
$result = dbquery("SELECT * FROM ".DB_AJAX_POLL." ORDER BY poll_started DESC LIMIT 1");
if (dbrows($result)) {
	$data = dbarray($result);
	$poll_votes = 0;
	for ($i=0; $i<=9; $i++) {
		if ($data['poll_opt_'.$i]) $poll_option[$i] = $data['poll_opt_'.$i];
		$poll_votes = $poll_votes + $data['poll_votes_'.$i];
	}
	$num_opts = count($poll_option);
	$poll_ips = explode("|", $data['poll_ips']);
	if(!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest' && isset($_POST['voteoption'])) {
		header("Content-Type: text/html; charset=".$locale['charset']."\n");
		ob_end_clean();
		ob_start();
		vote($_POST['poll_id'], $_POST['voteoption'], false);
		$data["poll_votes_".$_POST['voteoption']]++; $poll_votes++;
		showresult();
		$rslt = ob_get_contents();
		ob_end_clean();
		die($rslt);
	}
	if (isset($_COOKIE[COOKIE_PREFIX.'voted_'.$data['poll_id']]) || $data['poll_ended'] || iSUPERADMIN || in_array(USER_IP, $poll_ips)) {
		showresult();
	} else {
		showpoll();
	}
} else {
	echo "<div style='text-align:center'>".$locale['APP_111']."</div>\n";
}
closeside();

function vote($poll_id, $voteoption, $redirect = true) {
	global $link;
	$result = dbquery("SELECT * FROM ".DB_AJAX_POLL." WHERE poll_id='".$poll_id."'");
	if (dbrows($result)) {
		$data = dbarray($result);
		$poll_ips = explode("|", $data['poll_ips']);
		if (!in_array(USER_IP, $poll_ips) && $data['poll_opt_'.$voteoption] && !isset($_COOKIE[COOKIE_PREFIX.'voted_'.$poll_id]) && $data['poll_ended'] == 0) {
			setcookie(COOKIE_PREFIX."voted_".$poll_id, "yes", time() + 7776000, "/", "", "0");
			array_push($poll_ips, USER_IP);
			$poll_ips = implode("|", $poll_ips);
			$result = dbquery("UPDATE ".DB_AJAX_POLL." SET poll_votes_".$voteoption."=poll_votes_".$voteoption."+1, poll_ips='$poll_ips' WHERE poll_id=".$poll_id);
			if ($redirect) redirect($link);
		}
	} else {
		if ($redirect) redirect($link);
	}
}

function showresult() {
	global $data, $num_opts, $poll_votes, $poll_option, $locale;
	echo "<strong>".$data['poll_title']."</strong><br /><br />\n";
	for ($i=0; $i < $num_opts; $i++) {
		$num_votes = $data["poll_votes_".$i];
		$opt_votes = ($poll_votes ? number_format(100 / $poll_votes * $num_votes) : 0);
		echo "<div>".$poll_option[$i]."</div>\n";
		echo "<div><img src='".THEME."images/pollbar.gif' alt='".$poll_option[$i]."' style='height:12px;width:".$opt_votes."px;' class='poll' /></div>\n";
		echo "<div>".$opt_votes."% [".$num_votes." ".($num_votes == 1 ? $locale['APP_102'] : $locale['APP_103'])."]</div><br />\n";
	}
	echo "<div style='text-align:center'>".$locale['APP_104'].$poll_votes."<br />".$locale['APP_105'].showdate("shortdate", $data['poll_started'])."\n";
	if ($data['poll_ended'] > 0) {
		echo "<br />\n".$locale['APP_106'].showdate("shortdate", $data['poll_ended'])."\n";
	}
	$result = dbquery("SELECT * FROM ".DB_AJAX_POLL);
	if (dbrows($result) > 1) {
		echo "<br /><br /><img src='".THEME."images/bullet.gif' alt='' /> <a href='".INFUSIONS."ajax_poll_panel/ajax_poll_archive.php' class='side'>".$locale['APP_107']."</a> <img src='".THEME."images/bulletb.gif' alt='' />\n";
	}
	echo "</div>\n";
}

function showpoll() {
	global $data, $num_opts, $poll_option, $locale, $link;
	echo "<form id='poll' name='voteform' method='post' action='".$link."'>\n";
	echo "<strong>".$data['poll_title']."</strong><br /><br />\n";
	for ($i=0; $i < $num_opts; $i++) {
		echo "<input type='radio' name='voteoption' value='$i' />".$poll_option[$i]."<br /><br />\n";
	}
	echo "<input type='hidden' name='poll_id' value='".$data['poll_id']."' />\n";
	echo "<input type='submit' name='cast_vote' value='".$locale['APP_101']."' class='button' />\n";
	echo "</form>\n";
}

?>